
import platform
import matplotlib.pyplot as plt
import networkx as nx

def visualise(V, A):
    myPlat = platform.architecture()

    if myPlat[0] == "32bit":
        try:
            from networkx import graphviz_layout
        except ImportError:
            raise ImportError("This example needs Graphviz and PyGraphviz")
                              
        G = nx.Graph()
        G.add_nodes_from(V)
        G.add_edges_from(A)
        
        pos=nx.graphviz_layout(G,prog='dot',args='')
        plt.figure(figsize=(10,10))
        nx.draw(G,pos,node_size=300,alpha=0.5,node_color="blue")
        plt.axis('equal')
        plt.draw()
        plt.show()
        # To get the above code working I had to:
        # 1) Install GraphViz and download pygraphviz-x.x.zip
        # 2) Extract pygraphviz-x.x and edit setup.py in pygraphviz-1.1 directory, set
        #
        #    library_path="C:\\\"Program Files (x86)\"\\Graphviz 2.28\\lib\\release\\lib"
        #    include_path="C:\\\"Program Files (x86)\"\\Graphviz 2.28\\include\\graphviz"
        #
        # 3) go to msvc9compiler.py (in C:\Python27Win32\Lib\distutils\) and edit
        #    runtime_library_dir_option
        #
        #    def runtime_library_dir_option(self, dir):
        #        return "/LIBPATH:" + dir
        # ##       raise DistutilsPlatformError(
        # ##             "don't know how to set runtime library search path for MSVC++")
        #
        # 4) Run
        #
        #    c:\Python27Win32\python setup.py install
        #
        #    in pygraphviz-1.1 directory
        #
        # 5) Edit agraph.py in C:\Python27Win32\Lib\site-packages\pygraphviz
        #
        #
        #    def _run_prog(self,prog='nop',args=''):
        #        ...
        #        runprog=self._get_prog(prog)
        #        runprog = "\""+runprog+"\""

    else:
        print "Tree plot only defined for 32-bit Python..."

##    # This will work butnot look as nice if you can't get pygraphviz working
##    BinaryTree = {}
##    for v in V:
##        BinaryTree[v] = [w for (u, w) in A if v == u]
##
##    T=nx.Graph(BinaryTree)
##    nx.draw(T)
##    plt.draw()
##    plt.show()

##    # This apparently works well with the package SAGE, but it
##    # required virtual boxes, etc so I didn't try it
##
##    T=Graph(BinaryTree)
##    TREE=T.plot(graph_border=True,vertex_size=120, layout="tree",
##    tree_orientation="down",tree_root=0,vertex_colors="green",edge_colors="red")
##    TREE.show()
